<script lang="ts">
import Vue from 'vue';
import { init, refresh } from 'aos';
import { getPageMetadata } from '../common/meta';
import {
  NextStep as FeaturesCTA,
  SideNavigationVariant,
} from '../components/common/index';
import {
  SolutionsHero,
  SolutionsResourceCards,
} from '../components/solutions/index';
import {
  ByIndustryIntro,
  ByIndustryCaseStudies,
  ByIndustrySolutionsBlock,
} from '../components/solutions/by-industry/index';
import {
  BySolutionIntro,
  BySolutionBenefits,
  BySolutionValueProp,
} from '../components/solutions/by-solution/index';

export default Vue.extend({
  components: {
    SolutionsHero,
    ByIndustryIntro,
    SideNavigationVariant,
    BySolutionIntro,
    BySolutionBenefits,
    BySolutionValueProp,
    ByIndustryCaseStudies,
    ByIndustrySolutionsBlock,
    SolutionsResourceCards,
    FeaturesCTA,
  },
  async asyncData({ $content, error }: any) {
    try {
      const enterprise = await $content(`enterprise`).fetch();
      return { enterprise };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head() {
    return getPageMetadata((this as any).enterprise, this.$route.path);
  },
  beforeMount() {
    init({
      once: true,
    });
  },
  mounted() {
    refresh();
  },
});
</script>

<template>
  <div>
    <SolutionsHero :data="enterprise['solutions_hero']" />
    <ByIndustryIntro :data="enterprise['by_industry_intro']" />
    <SideNavigationVariant
      :links="[
        { title: 'Overview', href: '#overview' },
        { title: 'Benefits', href: '#benefits' },
        { title: 'Capabilities', href: '#capabilities' },
        { title: 'Case Studies', href: '#case-studies' },
      ]"
    >
      <div id="overview" data-slippers-scroll="overview">
        <BySolutionIntro :data="enterprise['by_solution_intro']" :offset="2" />
        <BySolutionBenefits
          :data="enterprise['by_solution_benefits']"
          :offset="2"
        />
      </div>
      <BySolutionValueProp
        id="benefits"
        :data="enterprise['by_solution_value_prop']"
        :justify-content="true"
        data-slippers-scroll="benefits"
      />
      <div
        id="capabilities"
        class="slp-my-96"
        data-slippers-scroll="capabilities"
      >
        <ByIndustrySolutionsBlock
          :data="enterprise['by_industry_solutions_block']"
          :offset="2"
        />
      </div>
      <ByIndustryCaseStudies
        id="case-studies"
        :data="enterprise['by_industry_case_studies']"
        :offset="2"
        data-slippers-scroll="case-studies"
      />
    </SideNavigationVariant>
    <SolutionsResourceCards :data="enterprise['solutions_resource_cards']" />
    <FeaturesCTA />
  </div>
</template>
